Index: /trunk/cli/convert.ml
===================================================================
--- /trunk/cli/convert.ml	(revision 14)
+++ /trunk/cli/convert.ml	(revision 15)
@@ -45,5 +45,5 @@
 		(match Header_pack.of_string @@ File_store.to_string fname with
 		| Error s -> prerr_endline s
-		| Ok { info; _ } ->
+		| Ok { info; peers; _ } ->
 			let kv = let f = Filename.concat dir ".convert.conf" in (* TODO: better place to store convert conf? *)
 				if Sys.file_exists f then File_store.of_kv_file f else Store.KV.empty in
@@ -51,4 +51,5 @@
 				else Store.KV.add "Title" info.Header_pack.title kv in
 			let kv = Store.KV.add "Locations" (String.concat ";\n" info.Header_pack.locations) kv in
+			let kv = Store.KV.add "Peers" (String.concat ";\n" Header_pack.(to_str_list peers)) kv in
 			let cs = converters types kv in
 			directory cs noindex dir info.Header_pack.id kv)
Index: /trunk/cli/gemini.ml
===================================================================
--- /trunk/cli/gemini.ml	(revision 14)
+++ /trunk/cli/gemini.ml	(revision 15)
@@ -72,9 +72,13 @@
   List.fold_left (fun a x -> a ^ list_item x x) "" (List.rev topic_roots)
 
-let topic_main_index title topic_roots metas =
-	"# " ^ title ^ "\n\n"
+let topic_main_index r title topic_roots metas =
+  "# " ^ title ^ "\n\n"
   ^ (if topic_roots <> [] then ("## Main topics\n\n" ^ fold_topic_roots topic_roots) else "")
   ^ "\n## Latest\n\n" ^ to_dated_links ~limit:10 metas
-  ^ "\n=> index.date.gmi More by date\n"
+  ^ "\n=> index.date.gmi More by date\n\n"
+  ^ let peers = Logarion.Store.KV.find "Peers" r.Conversion.kv in
+    if peers = "" then "" else
+    List.fold_left (fun a s -> Printf.sprintf "%s=> %s\n" a s) "## Peers\n\n"
+      (Str.split (Str.regexp ";\n") peers)
 
 let topic_sub_index title topic_map topic_root metas =
@@ -89,5 +93,5 @@
 
 	if index_name <> "" then
-		file index_name (topic_main_index title r.topic_roots r.texts);
+		file index_name (topic_main_index r title r.topic_roots r.texts);
 
 	file "index.date.gmi" (date_index title r.texts);
Index: /trunk/cli/html.ml
===================================================================
--- /trunk/cli/html.ml	(revision 14)
+++ /trunk/cli/html.ml	(revision 15)
@@ -37,5 +37,5 @@
 let topic_link root topic = 
   let replaced_space = String.map (function ' '->'+' | x->x) in
-  "<a href='index." ^ replaced_space root ^ ".htm#" ^ replaced_space topic ^ "'>"
+  "<a href='index." ^ root ^ ".htm#" ^ replaced_space topic ^ "'>"
   ^ String.capitalize_ascii topic ^ "</a>"
 
@@ -148,5 +148,10 @@
     (fold_topic_roots topic_roots
      ^ "<nav><h1>Latest</h1><ul>" ^ to_dated_links ~limit:8 metas
-     ^ {|</ul><a href="index.date.htm">More by date</a></nav>|} )
+     ^ {|</ul><a href="index.date.htm">More by date</a>|}
+     ^ let peers = Logarion.Store.KV.find "Peers" conv.kv in
+       (if peers = "" then "" else
+        List.fold_left (fun a s -> Printf.sprintf {|%s<li><a href="%s">%s</a>|} a s s) "<h1>Peers</h1><ul>"
+        (Str.split (Str.regexp ";\n") (Logarion.Store.KV.find "Peers" conv.kv))
+        ^ "</ul>"))
 
 let topic_sub_index conv htm topic_map topic_root metas =
@@ -172,6 +177,7 @@
 
 	let base_url = try
-		let _i = Str.(search_forward (regexp "https?://[^;]*") (Store.KV.find "Locations" c.kv) 0) in
-		Str.(matched_string (Store.KV.find "Locations" c.kv))
+		let locs = Store.KV.find "Locations" c.kv in
+		let _i = Str.(search_forward (regexp "https?://[^;]*") locs 0) in
+		Str.(matched_string locs)
 		with Not_found -> prerr_endline "Missing location for HTTP(S)"; "" in
 	file "feed.atom" (Atom.feed title c.id base_url "text/html" c.texts)
Index: /trunk/install
===================================================================
--- /trunk/install	(revision 14)
+++ /trunk/install	(revision 15)
@@ -3,5 +3,5 @@
 Requirements are ocaml (the compiler) and opam (the package manager). Then run:
 
-	opam pin add text_parse git://orbitalfox.eu/text-parse-ml
-	opam pin add logarion git://orbitalfox.eu/logarion
+	opam pin add text_parse https://git.disroot.org/orbifx/text-parse-ml.git
+	opam pin add logarion https://git.disroot.org/orbifx/logarion.git
 	opam install logarion
Index: /trunk/readme
===================================================================
--- /trunk/readme	(revision 14)
+++ /trunk/readme	(revision 15)
@@ -6,5 +6,5 @@
 
 Source: <http://git.disroot.org/orbifx/logarion>
-EUPL licence: <http://joinup.ec.europa.eu/software/page/eupl>
+Licence: EUPL <http://joinup.ec.europa.eu/software/page/eupl>
 
 IRC: <irc://tilde.chat/#logarion>